SystemOrganization addCategory: #'TADP-TP1'!
SystemOrganization addCategory: #'TADP-TP1-Tests'!

Trait named: #Estadistica
	uses: {}
	category: 'TADP-TP1'!

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:40'!
cantidadAbandonadas
^(self getMaterias select: [:materia | materia abandonada]) size 

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 17:20'!
cantidadAprobadas
^( self getMaterias select: [:materia | materia aprobada] ) size

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:54'!
cantidadAprobadasSobreCursadas

^((self getMaterias select: [:materia | materia aprobada]) size )/ ((self getMaterias select: [:materia | materia cursada]) size)

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 16:46'!
cantidadDesaprobadas
^(self getMaterias select: [:materia | materia not aprobada] size )

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/6/2013 09:53'!
getMaterias
	self requirement! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:45'!
listadoDeNotas
|col materias | 
col := Array  new:10.

materias := ((self getMaterias select: [ :materia | materia terminada]) collect: [:mat | mat nota]).


col at: 1 put: (materias occurrencesOf: 1).
col at:2 put: (materias occurrencesOf: 2).
col at:3 put:(materias occurrencesOf: 3).
col at:4 put:(materias occurrencesOf: 4).
col at:5 put:(materias occurrencesOf: 5).
col at:6 put:(materias occurrencesOf: 6).
col at:7 put:(materias occurrencesOf: 7).
col at:8 put: (materias occurrencesOf: 8).
col at:9 put:(materias occurrencesOf: 9).
col at:10 put:(materias occurrencesOf: 10).


^col! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 16:08'!
notaMasAlta: nVeces

|index listaInversa acum|
listaInversa := (self listadoDeNotas) reverse.
acum := nVeces.
index := 10.
listaInversa do: [:nota | nota >= acum ifTrue: [^index ] ifFalse:[acum := acum - nota. index := index -1] ].

"(11 - (listaInversa indexOf: nota))"! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 14:57'!
promedioConAplazos
|sumatoria|
sumatoria:= 0.
self getMaterias do: [:materia | sumatoria := sumatoria + materia nota ].

^(sumatoria / (self getMaterias size)).! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:51'!
promedioSinAplazos
|sumatoria|
sumatoria:= 0.
(self getMaterias select: [:materia | materia aprobada]) do: [:materiaAprobada | sumatoria := sumatoria + materiaAprobada  nota ].
^(sumatoria / (self getMaterias ;cantidadAprobadas) ).! !

Trait named: #Home
	uses: {}
	category: 'TADP-TP1'!

!Home classSide methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:27'!
newConHome: unHome
	^self new
		home: unHome;
		yourself.! !

TestCase subclass: #TP1Tests
	instanceVariableNames: 'estudiante curso carrera alumnoPerez cursoHistoria historia home profesorGarcia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1-Tests'!

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 09:43'!
setUp 
	home:= HomeMaterias new.
	alumnoPerez := Alumno newConHome: home .
	historia := Materia newConHome: home .
	profesorGarcia:= Docente new.
	cursoHistoria := Curso  newConHome: home .
	carrera := Carrera new.
	! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:57'!
testAlumnoCantidadAbandonadas
	|alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso  newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0 yAlumno: alumnoPerez yMateria: historia ).
	self assert: alumnoPerez cantidadAbandonadas equals: 2.
	self assert: alumnoRodriguez  cantidadAbandonadas equals: 1.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:05'!
testAlumnoCantidadAprobadas
	|alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso  newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0 yAlumno: alumnoPerez yMateria: historia ).
	self assert: alumnoPerez cantidadAprobadasSobreCursadas  equals: (3/5).
	self assert: alumnoRodriguez  cantidadAprobadasSobreCursadas   equals: (1/2).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:58'!
testAlumnoListado
|col|
col := Array new: 10.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	
col at: 1 put: 0.
col at: 2 put: 2.
col at: 3 put: 0.
col at: 4 put: 0.
col at: 5 put: 0.
col at: 6 put: 0.
col at: 7 put: 0.
col at: 8 put: 2.
col at: 9 put: 0.
col at: 10 put: 0.
	self assert: alumnoPerez listadoDeNotas  equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 16:03'!
testAlumnoNotaMasAltaNVeces
|resultado1 resultado2 resultado3|
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	resultado1  := alumnoPerez notaMasAlta: 4.
 	resultado2 := alumnoPerez notaMasAlta: 6.
	resultado3 := alumnoPerez notaMasAlta: 8.
	self assert: 10 equals: resultado1.		
	self assert: 8 equals: resultado2.
	self assert: 2 equals: resultado3.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:56'!
testAlumnoPromedioConAplazos

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
self assert: alumnoPerez promedioConAplazos equals: 4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:56'!
testAlumnoPromedioSinAplazos

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
self assert: 8 equals: alumnoPerez promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:20'!
testCarreraCantidadAbandonadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 2 equals: carrera cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:19'!
testCarreraCantidadAprobadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 4 equals: carrera cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:51'!
testCarreraListado
|alumnoRodriguez col|
col := Array new: 10.

alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	carrera addAlumno: alumnoPerez.

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: carrera listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:16'!
testCarreraPromedioConAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 5 equals: carrera promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:01'!
testCarreraPromedioSinAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 6 equals: carrera promedioSinAplazos.! !

Object subclass: #Alumno
	uses: Estadistica + Home
	instanceVariableNames: 'home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Alumno class
	uses: Estadistica classTrait + Home classTrait
	instanceVariableNames: ''!

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:24'!
getMaterias
	^(home getMateriasDeAlumno: self)! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:24'!
home
^ home! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

Object subclass: #Carrera
	uses: Estadistica
	instanceVariableNames: 'alumnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Carrera class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:21'!
addAlumno: unAlumno 
	alumnos  add: unAlumno  ! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:20'!
alumnos 
^alumnos ! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:50'!
getMaterias
|col|
col := Bag new.
(self alumnos do: [:alumno | col addAll: alumno getMaterias ]).
^col! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 17:29'!
initialize
alumnos := Set new.! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:07'!
viejoMaterias
	^(self alumnos collect: [:alumno | alumno getMaterias ])! !

Object subclass: #Curso
	uses: Estadistica + Home
	instanceVariableNames: 'anio cuatrimestre materia home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Curso class
	uses: Estadistica classTrait + Home classTrait
	instanceVariableNames: ''!

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:46'!
getMaterias
	^(home getMateriasDeCurso: self)! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home
^home! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

Object subclass: #Docente
	uses: Estadistica
	instanceVariableNames: 'cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Docente class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Docente methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:00'!
getMaterias
	^(self cursos collect: [:curso | curso getMaterias ])! !

Object subclass: #HomeMaterias
	instanceVariableNames: 'materiasCursadas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:23'!
addMateriaCursada: unaMateria
materiasCursadas add: unaMateria ! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:17'!
getMateriasDeAlumno: unAlumno
^(self materiasCursadas select: [:materia | materia  alumno  = unAlumno ])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:20'!
getMateriasDeCurso: unCurso
^(self materiasCursadas select: [:materia | materia curso  = unCurso])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:20'!
getMateriasDeMateria: unaMateria
^(self materiasCursadas select: [:materia | materia  materia  = unaMateria ])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 10:33'!
initialize 
materiasCursadas := Bag new.
! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 09:44'!
materiasCursadas
^materiasCursadas! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 09:44'!
materiasCursadas: materia
materiasCursadas:= materia  ! !

Object subclass: #Materia
	uses: Estadistica + Home
	instanceVariableNames: 'home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Materia class
	uses: Estadistica classTrait + Home classTrait
	instanceVariableNames: ''!

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:11'!
getMaterias
	^(self cursos collect: [:curso | curso getMaterias ])! !

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home
^home! !

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

Object subclass: #MateriaAbstracta
	instanceVariableNames: 'nota curso alumno materia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

MateriaAbstracta subclass: #MateriaAbandonada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:35'!
abandonada 
^true! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:06'!
aprobada

^false! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:06'!
cursada
 ^true! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^false! !

!MateriaAbstracta class methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:11'!
newConCurso: unCurso yNota: unaNota yAlumno: unAlumno  yMateria: unaMateria 
^self new
nota: unaNota;
curso: unCurso;
materia:  unaMateria ;
alumno: unAlumno ;
yourself.! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:21'!
abandonada
^ self subclassResponsibility! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
alumno
^alumno ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:09'!
alumno: unAlumno
alumno := unAlumno ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
curso
^curso ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
curso:unaNota
curso:=  unaNota ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
materia 
^materia ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
materia: unaMateria
materia := unaMateria ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
nota
^ nota! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
nota:unaNota
nota:=  unaNota ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^ self subclassResponsibility! !

MateriaAbstracta subclass: #MateriaEnCurso
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:36'!
abandonada
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
aprobada 
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
cursada
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^false! !

MateriaAbstracta subclass: #MateriaFirmada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:36'!
abandonada
^false! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:09'!
aprobada
^nota>3! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:10'!
cursada
^true! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:35'!
terminada
^true! !
